# zipson

[![Build Status](https://travis-ci.org/jgranstrom/zipson.svg?branch=master&style=flat)](https://travis-ci.org/jgranstrom/zipson)
[![npm version](https://badge.fury.io/js/zipson.svg)](http://badge.fury.io/js/zipson)
[![devDependencies Status](https://david-dm.org/jgranstrom/zipson/dev-status.svg)](https://david-dm.org/jgranstrom/zipson?type=dev)

### What is it?

Zipson is a performant JSON.parse/stringify alternative with built in compression and streaming support. It allows you to start parsing large sets of JSON data as it arrives. It supports any kind of JSON structure from simple to complex and provides better compression the bigger and more complex the data. It ensure that the compressed size never exceeds what a typical stringified JSON would, and will for the majority of cases provide a very high compression ratio of up to 50-90% reduction of strinfied size. It compresses and decompresses data in a single pass, and interleaves compression metadata with the actual data and structure of the JSON.

### Features

- Compress JSON to reduce size up to 50-90%
- Incremental compression
- Incremental decompression
- No schemas or details about the data structure needed
- Node and browser
- Optionally detect and heavly compress UTC timestamps `2018-01-01T00:00:00.000Z`
- Optionally reduce excess precision of floating point values
- Plays well with generic compression such as gzip
- Minimal overhead compared to JSON.parse and stringify
- Support for node.js streams using [zipson-stream](https://github.com/jgranstrom/zipson-stream)




write the readme and include information about required polyfills for es6 map and set

apply for browserstack open source for testing