(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function appendTemplateObjectValue(templateObjectTarget, targetValue) {
        const currentPath = templateObjectTarget.paths[templateObjectTarget.currentPathIndex];
        let i = 0;
        let targetObject = templateObjectTarget.currentObject;
        for (; i < currentPath.length - 1; i++) {
            const fragment = currentPath[i];
            targetObject = targetObject[fragment] = targetObject[fragment] || {};
        }
        targetObject[currentPath[i]] = targetValue;
    }
    function appendTemplateObjectPropertiesValue(templateObjectElementsTarget, targetValue) {
        if (templateObjectElementsTarget.currentPathIndex === -1) {
            templateObjectElementsTarget.value[targetValue] = templateObjectElementsTarget.currentObject = {};
        }
        else {
            appendTemplateObjectValue(templateObjectElementsTarget, targetValue);
        }
        if (++templateObjectElementsTarget.currentPathIndex === templateObjectElementsTarget.expectedPaths) {
            templateObjectElementsTarget.currentPathIndex = -1;
        }
    }
    exports.appendTemplateObjectPropertiesValue = appendTemplateObjectPropertiesValue;
    function appendTemplateObjectElementsValue(templateObjectPropertiesTarget, targetValue) {
        if (templateObjectPropertiesTarget.currentPathIndex === 0) {
            templateObjectPropertiesTarget.currentObject = {};
            templateObjectPropertiesTarget.value.push(templateObjectPropertiesTarget.currentObject);
        }
        appendTemplateObjectValue(templateObjectPropertiesTarget, targetValue);
        if (++templateObjectPropertiesTarget.currentPathIndex === templateObjectPropertiesTarget.expectedPaths) {
            templateObjectPropertiesTarget.currentPathIndex = 0;
        }
    }
    exports.appendTemplateObjectElementsValue = appendTemplateObjectElementsValue;
});
//# sourceMappingURL=util.js.map